using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Runtime.InteropServices;
using System.Data;

namespace UserAssistanceCSharp
{
	/// <summary>
	/// Summary description for Assistance.
	/// </summary>
	public class Assistance : System.Windows.Forms.Form
	{

		[DllImport("winmm.dll")]
		private static extern long sndPlaySoundA(string lpszSoundName, long uFlag);
		
		internal System.Data.OleDb.OleDbDataAdapter daHelpEvents;
		internal System.Data.OleDb.OleDbCommand OleDbSelectCommand2;
		internal System.Data.OleDb.OleDbConnection cnProactiveHelp;
		internal System.Data.OleDb.OleDbDataAdapter daSuggestionRules;
		internal System.Data.OleDb.OleDbCommand OleDbSelectCommand1;
		internal System.Windows.Forms.ContextMenu ContextMenu1;
		internal System.Windows.Forms.MenuItem MenuItem1;
		internal System.Windows.Forms.MenuItem MenuItem2;
		internal System.Windows.Forms.MenuItem MenuItem3;
		private CrystalDecisions.Windows.Forms.CrystalReportViewer crystalReportViewer1;
		private UserAssistanceCSharp.dsProactiveHelp dsFrmProactiveHelp;
		internal System.Windows.Forms.Button btnReset;
		internal System.Windows.Forms.Button btnTrigger;
		internal System.Windows.Forms.Label Label3;
		internal System.Windows.Forms.TextBox tbName;
		internal System.Windows.Forms.Label Label2;
		internal System.Windows.Forms.TextBox tbCustID;
		internal System.Windows.Forms.Label Label1;
		internal System.Windows.Forms.StatusBar StatusBar1;
		internal System.Windows.Forms.StatusBarPanel StatusBarPanel1;
		internal System.Windows.Forms.StatusBarPanel StatusBarPanel2;
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		public Assistance()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			foreach (Control ctrl in this.Controls)
				ctrl.Enter += new EventHandler(SetSBText);

			this.daSuggestionRules.Fill(this.dsFrmProactiveHelp.SuggestionRules);
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if(components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		[STAThread]
		static void Main()
		{
			Application.Run(new Assistance());
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.daHelpEvents = new System.Data.OleDb.OleDbDataAdapter();
			this.OleDbSelectCommand2 = new System.Data.OleDb.OleDbCommand();
			this.cnProactiveHelp = new System.Data.OleDb.OleDbConnection();
			this.daSuggestionRules = new System.Data.OleDb.OleDbDataAdapter();
			this.OleDbSelectCommand1 = new System.Data.OleDb.OleDbCommand();
			this.ContextMenu1 = new System.Windows.Forms.ContextMenu();
			this.MenuItem1 = new System.Windows.Forms.MenuItem();
			this.MenuItem2 = new System.Windows.Forms.MenuItem();
			this.MenuItem3 = new System.Windows.Forms.MenuItem();
			this.crystalReportViewer1 = new CrystalDecisions.Windows.Forms.CrystalReportViewer();
			this.dsFrmProactiveHelp = new UserAssistanceCSharp.dsProactiveHelp();
			this.btnReset = new System.Windows.Forms.Button();
			this.btnTrigger = new System.Windows.Forms.Button();
			this.Label3 = new System.Windows.Forms.Label();
			this.tbName = new System.Windows.Forms.TextBox();
			this.Label2 = new System.Windows.Forms.Label();
			this.tbCustID = new System.Windows.Forms.TextBox();
			this.Label1 = new System.Windows.Forms.Label();
			this.StatusBar1 = new System.Windows.Forms.StatusBar();
			this.StatusBarPanel1 = new System.Windows.Forms.StatusBarPanel();
			this.StatusBarPanel2 = new System.Windows.Forms.StatusBarPanel();
			((System.ComponentModel.ISupportInitialize)(this.dsFrmProactiveHelp)).BeginInit();
			((System.ComponentModel.ISupportInitialize)(this.StatusBarPanel1)).BeginInit();
			((System.ComponentModel.ISupportInitialize)(this.StatusBarPanel2)).BeginInit();
			this.SuspendLayout();
			// 
			// daHelpEvents
			// 
			this.daHelpEvents.SelectCommand = this.OleDbSelectCommand2;
			this.daHelpEvents.TableMappings.AddRange(new System.Data.Common.DataTableMapping[] {
																								   new System.Data.Common.DataTableMapping("Table", "HelpEvents", new System.Data.Common.DataColumnMapping[] {
																																																				 new System.Data.Common.DataColumnMapping("Command", "Command"),
																																																				 new System.Data.Common.DataColumnMapping("FormName", "FormName"),
																																																				 new System.Data.Common.DataColumnMapping("Time", "Time")})});
			// 
			// OleDbSelectCommand2
			// 
			this.OleDbSelectCommand2.CommandText = "SELECT Command, FormName, [Time] FROM HelpEvents";
			this.OleDbSelectCommand2.Connection = this.cnProactiveHelp;
			// 
			// cnProactiveHelp
			// 
			this.cnProactiveHelp.ConnectionString = @"Jet OLEDB:Global Partial Bulk Ops=2;Jet OLEDB:Registry Path=;Jet OLEDB:Database Locking Mode=1;Data Source=""..\..\ProactiveHelp.mdb"";Jet OLEDB:Engine Type=5;Provider=""Microsoft.Jet.OLEDB.4.0"";Jet OLEDB:System database=;Jet OLEDB:SFP=False;persist security info=False;Extended Properties=;Mode=Share Deny None;Jet OLEDB:Encrypt Database=False;Jet OLEDB:Create System Database=False;Jet OLEDB:Don't Copy Locale on Compact=False;Jet OLEDB:Compact Without Replica Repair=False;User ID=Admin;Jet OLEDB:Global Bulk Transactions=1";
			// 
			// daSuggestionRules
			// 
			this.daSuggestionRules.SelectCommand = this.OleDbSelectCommand1;
			this.daSuggestionRules.TableMappings.AddRange(new System.Data.Common.DataTableMapping[] {
																										new System.Data.Common.DataTableMapping("Table", "SuggestionRules", new System.Data.Common.DataColumnMapping[] {
																																																						   new System.Data.Common.DataColumnMapping("Command", "Command"),
																																																						   new System.Data.Common.DataColumnMapping("Disable", "Disable"),
																																																						   new System.Data.Common.DataColumnMapping("FormName", "FormName"),
																																																						   new System.Data.Common.DataColumnMapping("Suggestion", "Suggestion"),
																																																						   new System.Data.Common.DataColumnMapping("SuggestionID", "SuggestionID"),
																																																						   new System.Data.Common.DataColumnMapping("Trigger", "Trigger")})});
			// 
			// OleDbSelectCommand1
			// 
			this.OleDbSelectCommand1.CommandText = "SELECT Command, Disable, FormName, Suggestion, SuggestionID, Trigger FROM Suggest" +
				"ionRules WHERE (FormName = \'Assistance\') AND (Disable = False)";
			this.OleDbSelectCommand1.Connection = this.cnProactiveHelp;
			// 
			// ContextMenu1
			// 
			this.ContextMenu1.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
																						 this.MenuItem1,
																						 this.MenuItem2,
																						 this.MenuItem3});
			// 
			// MenuItem1
			// 
			this.MenuItem1.Index = 0;
			this.MenuItem1.Text = "Item One";
			// 
			// MenuItem2
			// 
			this.MenuItem2.Index = 1;
			this.MenuItem2.Text = "Item Two";
			// 
			// MenuItem3
			// 
			this.MenuItem3.Index = 2;
			this.MenuItem3.Text = "Item Three";
			// 
			// crystalReportViewer1
			// 
			this.crystalReportViewer1.ActiveViewIndex = -1;
			this.crystalReportViewer1.Location = new System.Drawing.Point(0, 0);
			this.crystalReportViewer1.Name = "crystalReportViewer1";
			this.crystalReportViewer1.ReportSource = null;
			this.crystalReportViewer1.TabIndex = 0;
			// 
			// dsFrmProactiveHelp
			// 
			this.dsFrmProactiveHelp.DataSetName = "dsProactiveHelp";
			this.dsFrmProactiveHelp.Locale = new System.Globalization.CultureInfo("en-US");
			// 
			// btnReset
			// 
			this.btnReset.CausesValidation = false;
			this.btnReset.Location = new System.Drawing.Point(296, 44);
			this.btnReset.Name = "btnReset";
			this.btnReset.Size = new System.Drawing.Size(88, 32);
			this.btnReset.TabIndex = 15;
			this.btnReset.Text = "&Reset Reactive Help";
			this.btnReset.Click += new System.EventHandler(this.btnReset_Click);
			// 
			// btnTrigger
			// 
			this.btnTrigger.CausesValidation = false;
			this.btnTrigger.Location = new System.Drawing.Point(296, 4);
			this.btnTrigger.Name = "btnTrigger";
			this.btnTrigger.Size = new System.Drawing.Size(88, 32);
			this.btnTrigger.TabIndex = 14;
			this.btnTrigger.Text = "&Trigger Reactive Help";
			this.btnTrigger.Click += new System.EventHandler(this.btnTrigger_Click);
			// 
			// Label3
			// 
			this.Label3.Location = new System.Drawing.Point(16, 68);
			this.Label3.Name = "Label3";
			this.Label3.Size = new System.Drawing.Size(264, 72);
			this.Label3.TabIndex = 13;
			this.Label3.Text = "Note:  This example uses a lighter-weight method for playing sounds than that des" +
				"cribed in the text.  It calls the winmm.dll rather than instantiating the Media " +
				"Player.  My thanks to Stephen Jeffries for this technique.";
			// 
			// tbName
			// 
			this.tbName.Location = new System.Drawing.Point(88, 28);
			this.tbName.Name = "tbName";
			this.tbName.Size = new System.Drawing.Size(192, 20);
			this.tbName.TabIndex = 12;
			this.tbName.Tag = "The full name of an individual.";
			this.tbName.Text = "Customer Name";
			// 
			// Label2
			// 
			this.Label2.AutoSize = true;
			this.Label2.Location = new System.Drawing.Point(41, 30);
			this.Label2.Name = "Label2";
			this.Label2.Size = new System.Drawing.Size(38, 16);
			this.Label2.TabIndex = 11;
			this.Label2.Text = "Name:";
			// 
			// tbCustID
			// 
			this.tbCustID.Location = new System.Drawing.Point(88, 4);
			this.tbCustID.Name = "tbCustID";
			this.tbCustID.Size = new System.Drawing.Size(88, 20);
			this.tbCustID.TabIndex = 10;
			this.tbCustID.Tag = "This value is assigned by the system.";
			this.tbCustID.Text = "custID";
			this.tbCustID.Validating += new System.ComponentModel.CancelEventHandler(this.tbCustID_Validating);
			// 
			// Label1
			// 
			this.Label1.AutoSize = true;
			this.Label1.Location = new System.Drawing.Point(8, 6);
			this.Label1.Name = "Label1";
			this.Label1.Size = new System.Drawing.Size(71, 16);
			this.Label1.TabIndex = 9;
			this.Label1.Text = "Customer ID:";
			// 
			// StatusBar1
			// 
			this.StatusBar1.ContextMenu = this.ContextMenu1;
			this.StatusBar1.Location = new System.Drawing.Point(0, 159);
			this.StatusBar1.Name = "StatusBar1";
			this.StatusBar1.Panels.AddRange(new System.Windows.Forms.StatusBarPanel[] {
																						  this.StatusBarPanel1,
																						  this.StatusBarPanel2});
			this.StatusBar1.ShowPanels = true;
			this.StatusBar1.Size = new System.Drawing.Size(392, 22);
			this.StatusBar1.TabIndex = 8;
			this.StatusBar1.PanelClick += new System.Windows.Forms.StatusBarPanelClickEventHandler(this.StatusBar1_PanelClick);
			// 
			// StatusBarPanel1
			// 
			this.StatusBarPanel1.Text = "Edit";
			this.StatusBarPanel1.Width = 50;
			// 
			// StatusBarPanel2
			// 
			this.StatusBarPanel2.AutoSize = System.Windows.Forms.StatusBarPanelAutoSize.Spring;
			this.StatusBarPanel2.Text = "StatusBarPanel2";
			this.StatusBarPanel2.Width = 326;
			// 
			// Assistance
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(392, 181);
			this.Controls.Add(this.btnReset);
			this.Controls.Add(this.btnTrigger);
			this.Controls.Add(this.Label3);
			this.Controls.Add(this.tbName);
			this.Controls.Add(this.Label2);
			this.Controls.Add(this.tbCustID);
			this.Controls.Add(this.Label1);
			this.Controls.Add(this.StatusBar1);
			this.Name = "Assistance";
			this.Text = "Assistance";
			((System.ComponentModel.ISupportInitialize)(this.dsFrmProactiveHelp)).EndInit();
			((System.ComponentModel.ISupportInitialize)(this.StatusBarPanel1)).EndInit();
			((System.ComponentModel.ISupportInitialize)(this.StatusBarPanel2)).EndInit();
			this.ResumeLayout(false);

		}
		#endregion
		#region StatusBar Menus
		private void SetSBText(Object sender, System.EventArgs e)
		{
			Control ctrl = sender as Control;

			this.StatusBarPanel2.Text = (string)ctrl.Tag;
		}

		private void StatusBar1_PanelClick(object sender, System.Windows.Forms.StatusBarPanelClickEventArgs e)
		{
			if (e.Button == MouseButtons.Right)
				this.ContextMenu1.Show(this.StatusBar1, new Point(e.X, e.Y));
		}

		#endregion
		#region Sound

		public void PlaySoundFile(string fileName)
		{
			long x;
			x = sndPlaySoundA(fileName, 1);
		}

		private void tbCustID_Validating(object sender, System.ComponentModel.CancelEventArgs e)
		{
			try
			{
				int.Parse(this.tbCustID.Text);
				PlaySoundFile("ding.wav");
			}
			catch 
			{
				PlaySoundFile("notify.wav");
				CustomMessage theMsg = new CustomMessage("Please enter a numeric value.");
				theMsg.ShowDialog();
			}
		}
		#endregion

		private void btnReset_Click(object sender, System.EventArgs e)
		{
			this.dsFrmProactiveHelp.HelpEvents.Clear();
		}

		private void btnTrigger_Click(object sender, System.EventArgs e)
		{
			string cmd = "btnTrigger_Click";

			dsProactiveHelp.HelpEventsRow drEvent;
			drEvent = (dsProactiveHelp.HelpEventsRow )this.dsFrmProactiveHelp.HelpEvents.NewRow();

			drEvent.Command = cmd;
			drEvent.FormName = "Assistance";
			drEvent.Time = DateTime.Now;
			this.dsFrmProactiveHelp.HelpEvents.Rows.Add(drEvent);

			DataView dvRule = new DataView(this.dsFrmProactiveHelp.SuggestionRules);
			int theRow;
			dvRule.Sort = "Command";
			theRow = dvRule.Find(cmd);

			dsProactiveHelp.SuggestionRulesRow drRule;
			drRule = (dsProactiveHelp.SuggestionRulesRow)this.dsFrmProactiveHelp.SuggestionRules.Rows[theRow];

			DataView dv = this.dsFrmProactiveHelp.HelpEvents.DefaultView;
			dv.RowFilter = "Command = '" + cmd + "'";
			if (dv.Count == drRule.Trigger)
			{
				CustomMessage theMsg = new CustomMessage(drRule.Suggestion);
				theMsg.ShowDialog();
			}
		}

	}
}
