using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;

namespace DataBindingCSharp
{
	/// <summary>
	/// Summary description for BindingExerciser.
	/// </summary>
	public class BindingExerciser : System.Windows.Forms.Form
	{
		String myString = "Test";
		TextBox tb = new TextBox();
		Binding propBinding;
															   
		internal System.Windows.Forms.Button btnInfo;
		internal System.Windows.Forms.Button btnClass;
		internal System.Windows.Forms.Button btnFont;
		internal System.Windows.Forms.Button btnRecalc;
		internal System.Windows.Forms.Label Label3;
		internal System.Windows.Forms.TextBox tbClass;
		internal System.Windows.Forms.Label Label2;
		internal System.Windows.Forms.TextBox tbProperty;
		internal System.Windows.Forms.Label Label1;
		internal System.Windows.Forms.TextBox tbString;
		internal System.Windows.Forms.ListBox ListBox1;
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		public BindingExerciser()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			//Simple-bind to a property
            propBinding = new Binding("Text", ListBox1, "Font.Name");
			this.tbProperty.DataBindings.Add(propBinding);

			//Simple-bind to a class
			tb.Text = "Test";
			Binding clsBinding = new Binding("Text", tb, "Text");
			this.tbClass.DataBindings.Add(clsBinding);

			//Simple-bind to a String
			Binding strBinding = new Binding("Text", myString, "");
			this.tbString.DataBindings.Add(strBinding);

			//Complex-bind a listbox
			ArrayList lbItems = new ArrayList();
			lbItems.Add("Item One");
			lbItems.Add("Two");
			lbItems.Add("Three");
			this.ListBox1.DataSource = lbItems;
			
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if(components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.btnInfo = new System.Windows.Forms.Button();
			this.btnClass = new System.Windows.Forms.Button();
			this.btnFont = new System.Windows.Forms.Button();
			this.btnRecalc = new System.Windows.Forms.Button();
			this.Label3 = new System.Windows.Forms.Label();
			this.tbClass = new System.Windows.Forms.TextBox();
			this.Label2 = new System.Windows.Forms.Label();
			this.tbProperty = new System.Windows.Forms.TextBox();
			this.Label1 = new System.Windows.Forms.Label();
			this.tbString = new System.Windows.Forms.TextBox();
			this.ListBox1 = new System.Windows.Forms.ListBox();
			this.SuspendLayout();
			// 
			// btnInfo
			// 
			this.btnInfo.Font = new System.Drawing.Font("Microsoft Sans Serif", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.btnInfo.Location = new System.Drawing.Point(288, 104);
			this.btnInfo.Name = "btnInfo";
			this.btnInfo.Size = new System.Drawing.Size(80, 23);
			this.btnInfo.TabIndex = 21;
			this.btnInfo.Text = "MemberInfo";
			this.btnInfo.Click += new System.EventHandler(this.btnInfo_Click);
			// 
			// btnClass
			// 
			this.btnClass.Font = new System.Drawing.Font("Microsoft Sans Serif", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.btnClass.Location = new System.Drawing.Point(288, 40);
			this.btnClass.Name = "btnClass";
			this.btnClass.Size = new System.Drawing.Size(80, 23);
			this.btnClass.TabIndex = 20;
			this.btnClass.Text = "Class";
			this.btnClass.Click += new System.EventHandler(this.btnClass_Click);
			// 
			// btnFont
			// 
			this.btnFont.Font = new System.Drawing.Font("Microsoft Sans Serif", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.btnFont.Location = new System.Drawing.Point(288, 8);
			this.btnFont.Name = "btnFont";
			this.btnFont.Size = new System.Drawing.Size(80, 23);
			this.btnFont.TabIndex = 19;
			this.btnFont.Text = "Change Font";
			this.btnFont.Click += new System.EventHandler(this.btnFont_Click);
			// 
			// btnRecalc
			// 
			this.btnRecalc.Font = new System.Drawing.Font("Microsoft Sans Serif", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.btnRecalc.Location = new System.Drawing.Point(288, 72);
			this.btnRecalc.Name = "btnRecalc";
			this.btnRecalc.Size = new System.Drawing.Size(80, 23);
			this.btnRecalc.TabIndex = 18;
			this.btnRecalc.Text = "String";
			this.btnRecalc.Click += new System.EventHandler(this.btnRecalc_Click);
			// 
			// Label3
			// 
			this.Label3.AutoSize = true;
			this.Label3.Font = new System.Drawing.Font("Microsoft Sans Serif", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.Label3.Location = new System.Drawing.Point(136, 48);
			this.Label3.Name = "Label3";
			this.Label3.Size = new System.Drawing.Size(82, 16);
			this.Label3.TabIndex = 17;
			this.Label3.Text = "Class Property:";
			// 
			// tbClass
			// 
			this.tbClass.Font = new System.Drawing.Font("Microsoft Sans Serif", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.tbClass.Location = new System.Drawing.Point(136, 64);
			this.tbClass.Name = "tbClass";
			this.tbClass.Size = new System.Drawing.Size(136, 20);
			this.tbClass.TabIndex = 16;
			this.tbClass.Text = "tbClass";
			// 
			// Label2
			// 
			this.Label2.AutoSize = true;
			this.Label2.Font = new System.Drawing.Font("Microsoft Sans Serif", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.Label2.Location = new System.Drawing.Point(136, 8);
			this.Label2.Name = "Label2";
			this.Label2.Size = new System.Drawing.Size(90, 16);
			this.Label2.TabIndex = 15;
			this.Label2.Text = "Control Property:";
			// 
			// tbProperty
			// 
			this.tbProperty.Font = new System.Drawing.Font("Microsoft Sans Serif", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.tbProperty.Location = new System.Drawing.Point(136, 24);
			this.tbProperty.Name = "tbProperty";
			this.tbProperty.Size = new System.Drawing.Size(136, 20);
			this.tbProperty.TabIndex = 14;
			this.tbProperty.Text = "tbProperty";
			// 
			// Label1
			// 
			this.Label1.AutoSize = true;
			this.Label1.Font = new System.Drawing.Font("Microsoft Sans Serif", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.Label1.Location = new System.Drawing.Point(136, 96);
			this.Label1.Name = "Label1";
			this.Label1.Size = new System.Drawing.Size(73, 16);
			this.Label1.TabIndex = 13;
			this.Label1.Text = "Bound String:";
			// 
			// tbString
			// 
			this.tbString.Font = new System.Drawing.Font("Microsoft Sans Serif", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.tbString.Location = new System.Drawing.Point(136, 112);
			this.tbString.Name = "tbString";
			this.tbString.Size = new System.Drawing.Size(136, 20);
			this.tbString.TabIndex = 12;
			this.tbString.Text = "tbString";
			// 
			// ListBox1
			// 
			this.ListBox1.Font = new System.Drawing.Font("Microsoft Sans Serif", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.ListBox1.Location = new System.Drawing.Point(8, 8);
			this.ListBox1.Name = "ListBox1";
			this.ListBox1.Size = new System.Drawing.Size(120, 121);
			this.ListBox1.TabIndex = 11;
			// 
			// BindingExerciser
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(376, 149);
			this.Controls.Add(this.btnInfo);
			this.Controls.Add(this.btnClass);
			this.Controls.Add(this.btnFont);
			this.Controls.Add(this.btnRecalc);
			this.Controls.Add(this.Label3);
			this.Controls.Add(this.tbClass);
			this.Controls.Add(this.Label2);
			this.Controls.Add(this.tbProperty);
			this.Controls.Add(this.Label1);
			this.Controls.Add(this.tbString);
			this.Controls.Add(this.ListBox1);
			this.Name = "BindingExerciser";
			this.Text = "BindingExerciser";
			this.ResumeLayout(false);

		}
		#endregion

		private void btnRecalc_Click(object sender, System.EventArgs e)
		{
			if (myString == "Test") 
	            myString = "New Test";
			else
				myString = "Test";
						
			MessageBox.Show(myString);
		}

		private void btnClass_Click(object sender, System.EventArgs e)
		{
			if (tbClass.Text == "Test" )
				tbClass.Text = "New Test";
			else
				tbClass.Text = "Test";
		}

		private void btnFont_Click(object sender, System.EventArgs e)
		{
			Font myFont;
			if (ListBox1.Font.Name == "Times New Roman")
				myFont = new System.Drawing.Font("Tempus Sans ITC", 11);
			else
				myFont = new System.Drawing.Font("Times New Roman", 11);
        
			ListBox1.Font = myFont;
		}

		private void btnInfo_Click(object sender, System.EventArgs e)
		{
			Info myForm = new Info();
			BindingMemberInfo bmi = propBinding.BindingMemberInfo;

			myForm.tbField.Text = bmi.BindingField.ToString();
			myForm.tbMember.Text = bmi.BindingMember.ToString();
			myForm.tbPath.Text = bmi.BindingPath.ToString();

			myForm.ShowDialog();

		}
	}
}
