using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;

namespace UserCustomizationCSharp
{
	/// <summary>
	/// Summary description for Configure.
	/// </summary>
	public class Configure : System.Windows.Forms.Form
	{
		private UserCustomizationCSharp.UserSettings dsUserSettings;
		internal System.Windows.Forms.Label Label1;
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		public Configure()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			AddRows();

			this.Label1.Font = MakeFont("DisplayFontName", "DisplayFontSize");
			this.Label1.ForeColor = MakeColor("ForeColorRed", "ForeColorGreen", "ForeColorBlue");
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if(components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.dsUserSettings = new UserCustomizationCSharp.UserSettings();
			this.Label1 = new System.Windows.Forms.Label();
			((System.ComponentModel.ISupportInitialize)(this.dsUserSettings)).BeginInit();
			this.SuspendLayout();
			// 
			// dsUserSettings
			// 
			this.dsUserSettings.DataSetName = "UserSettings";
			this.dsUserSettings.Locale = new System.Globalization.CultureInfo("en-US");
			// 
			// Label1
			// 
			this.Label1.Font = new System.Drawing.Font("Microsoft Sans Serif", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.Label1.Location = new System.Drawing.Point(16, 16);
			this.Label1.Name = "Label1";
			this.Label1.TabIndex = 1;
			this.Label1.Text = "Label1";
			// 
			// Configure
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(368, 62);
			this.Controls.Add(this.Label1);
			this.Name = "Configure";
			this.Text = "Configure";
			((System.ComponentModel.ISupportInitialize)(this.dsUserSettings)).EndInit();
			this.ResumeLayout(false);

		}
		#endregion

		private void AddRows()
		{
			UserSettings.DisplayPropertiesRow newRow;
			
			newRow = this.dsUserSettings.DisplayProperties.NewDisplayPropertiesRow();
			newRow.UserName = "Admin";
			newRow.PropertyName = "DisplayFontName";
			newRow.PropertyValue = "Tempus Sans ITC";
			this.dsUserSettings.DisplayProperties.Rows.Add(newRow);

			newRow = this.dsUserSettings.DisplayProperties.NewDisplayPropertiesRow();
			newRow.UserName = "Admin";
			newRow.PropertyName = "DisplayFontSize";
			newRow.PropertyValue = "8.2";
			this.dsUserSettings.DisplayProperties.Rows.Add(newRow);

			newRow = this.dsUserSettings.DisplayProperties.NewDisplayPropertiesRow();
			newRow.UserName = "Admin";
			newRow.PropertyName = "ForeColorRed";
			newRow.PropertyValue = "255";
			this.dsUserSettings.DisplayProperties.Rows.Add(newRow);

			newRow = this.dsUserSettings.DisplayProperties.NewDisplayPropertiesRow();
			newRow.UserName = "Admin";
			newRow.PropertyName = "ForeColorBlue";
			newRow.PropertyValue = "0";
			this.dsUserSettings.DisplayProperties.Rows.Add(newRow);

			newRow = this.dsUserSettings.DisplayProperties.NewDisplayPropertiesRow();
			newRow.UserName = "Admin";
			newRow.PropertyName = "ForeColorGreen";
			newRow.PropertyValue = "0";
			this.dsUserSettings.DisplayProperties.Rows.Add(newRow);
		}

		private Font MakeFont(string theName, string theSize)
		{
			int curRowIdx;
			UserSettings.DisplayPropertiesDataTable dt = this.dsUserSettings.DisplayProperties;

			dt.DefaultView.Sort = "PropertyName";

            string fontName;
            curRowIdx = dt.DefaultView.Find(theName);
            fontName = dt.Rows[curRowIdx]["PropertyValue"] as string;


            float fontSize;
            curRowIdx = dt.DefaultView.Find(theSize);
            fontSize = Single.Parse((string)dt.Rows[curRowIdx]["PropertyValue"]);

            return new Font(fontName, fontSize);
		}

		private Color MakeColor(string theRed, string theGreen, string theBlue)
		{
			int curRowIdx;
			int clrRed;
			int clrGreen;
			int clrBlue;

			UserSettings.DisplayPropertiesDataTable dt = this.dsUserSettings.DisplayProperties;

			dt.DefaultView.Sort = "PropertyName";

			curRowIdx = dt.DefaultView.Find(theRed);
			clrRed = int.Parse((string)dt.Rows[curRowIdx]["PropertyValue"]);

			curRowIdx = dt.DefaultView.Find(theGreen);
			clrGreen = int.Parse((string)dt.Rows[curRowIdx]["PropertyValue"]);

			curRowIdx = dt.DefaultView.Find(theBlue);
			clrBlue = int.Parse((string)dt.Rows[curRowIdx]["PropertyValue"]);

			return Color.FromArgb(clrRed, clrGreen, clrBlue);
		}
	}
}
