using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;

namespace ListControlsCSharp
{
	/// <summary>
	/// Summary description for FilteredListbox.
	/// </summary>
	public class FilteredListbox : System.Windows.Forms.Form
	{

		internal System.Windows.Forms.Label Label2;
		internal System.Windows.Forms.Label Label1;
		internal System.Data.OleDb.OleDbDataAdapter daRepresentatives;
		internal System.Data.OleDb.OleDbCommand OleDbSelectCommand2;
		internal System.Data.OleDb.OleDbConnection cnChapter13;
		internal System.Data.OleDb.OleDbCommand OleDbSelectCommand1;
		internal System.Data.OleDb.OleDbDataAdapter daCustomerList;
		private ListControlsCSharp.dsChapter13 dsFrmChapter13;
		internal System.Windows.Forms.ListBox lbCustomers;
		internal System.Windows.Forms.ListBox lbReps;
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		public FilteredListbox()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			try
			{
				this.daRepresentatives.Fill(this.dsFrmChapter13, "Representatives");
				this.daCustomerList.Fill(this.dsFrmChapter13, "CustomerList");
			}
			catch (Exception ex)
			{
				MessageBox.Show(ex.Message);
			}
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if(components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		[STAThread]
		static void Main() 
		{
			Application.Run(new FilteredListbox());
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.Label2 = new System.Windows.Forms.Label();
			this.Label1 = new System.Windows.Forms.Label();
			this.daRepresentatives = new System.Data.OleDb.OleDbDataAdapter();
			this.OleDbSelectCommand2 = new System.Data.OleDb.OleDbCommand();
			this.cnChapter13 = new System.Data.OleDb.OleDbConnection();
			this.OleDbSelectCommand1 = new System.Data.OleDb.OleDbCommand();
			this.daCustomerList = new System.Data.OleDb.OleDbDataAdapter();
			this.dsFrmChapter13 = new ListControlsCSharp.dsChapter13();
			this.lbCustomers = new System.Windows.Forms.ListBox();
			this.lbReps = new System.Windows.Forms.ListBox();
			((System.ComponentModel.ISupportInitialize)(this.dsFrmChapter13)).BeginInit();
			this.SuspendLayout();
			// 
			// Label2
			// 
			this.Label2.AutoSize = true;
			this.Label2.Location = new System.Drawing.Point(27, 7);
			this.Label2.Name = "Label2";
			this.Label2.Size = new System.Drawing.Size(86, 16);
			this.Label2.TabIndex = 7;
			this.Label2.Text = "Representatives";
			// 
			// Label1
			// 
			this.Label1.AutoSize = true;
			this.Label1.Location = new System.Drawing.Point(235, 7);
			this.Label1.Name = "Label1";
			this.Label1.Size = new System.Drawing.Size(171, 16);
			this.Label1.TabIndex = 6;
			this.Label1.Text = "This Representative\'s Customers";
			// 
			// daRepresentatives
			// 
			this.daRepresentatives.SelectCommand = this.OleDbSelectCommand2;
			this.daRepresentatives.TableMappings.AddRange(new System.Data.Common.DataTableMapping[] {
																										new System.Data.Common.DataTableMapping("Table", "Representatives", new System.Data.Common.DataColumnMapping[] {
																																																						   new System.Data.Common.DataColumnMapping("RepID", "RepID"),
																																																						   new System.Data.Common.DataColumnMapping("RepName", "RepName")})});
			// 
			// OleDbSelectCommand2
			// 
			this.OleDbSelectCommand2.CommandText = "SELECT RepID, RepName FROM Representatives";
			this.OleDbSelectCommand2.Connection = this.cnChapter13;
			// 
			// cnChapter13
			// 
			this.cnChapter13.ConnectionString = @"Jet OLEDB:Global Partial Bulk Ops=2;Jet OLEDB:Registry Path=;Jet OLEDB:Database Locking Mode=1;Data Source=""..\..\Chapter13.mdb"";Jet OLEDB:Engine Type=5;Provider=""Microsoft.Jet.OLEDB.4.0"";Jet OLEDB:System database=;Jet OLEDB:SFP=False;persist security info=False;Extended Properties=;Mode=Share Deny None;Jet OLEDB:Encrypt Database=False;Jet OLEDB:Create System Database=False;Jet OLEDB:Don't Copy Locale on Compact=False;Jet OLEDB:Compact Without Replica Repair=False;User ID=Admin;Jet OLEDB:Global Bulk Transactions=1";
			// 
			// OleDbSelectCommand1
			// 
			this.OleDbSelectCommand1.CommandText = "SELECT CustomerID, CustomerName, RepID FROM CustomerList";
			this.OleDbSelectCommand1.Connection = this.cnChapter13;
			// 
			// daCustomerList
			// 
			this.daCustomerList.SelectCommand = this.OleDbSelectCommand1;
			this.daCustomerList.TableMappings.AddRange(new System.Data.Common.DataTableMapping[] {
																									 new System.Data.Common.DataTableMapping("Table", "CustomerList", new System.Data.Common.DataColumnMapping[] {
																																																					 new System.Data.Common.DataColumnMapping("CustomerID", "CustomerID"),
																																																					 new System.Data.Common.DataColumnMapping("CustomerName", "CustomerName"),
																																																					 new System.Data.Common.DataColumnMapping("RepID", "RepID")})});
			// 
			// dsFrmChapter13
			// 
			this.dsFrmChapter13.DataSetName = "dsChapter13";
			this.dsFrmChapter13.Locale = new System.Globalization.CultureInfo("en-US");
			// 
			// lbCustomers
			// 
			this.lbCustomers.DataSource = this.dsFrmChapter13;
			this.lbCustomers.DisplayMember = "Representatives.RepresentativesCustomerList.CustomerName";
			this.lbCustomers.Location = new System.Drawing.Point(235, 24);
			this.lbCustomers.Name = "lbCustomers";
			this.lbCustomers.Size = new System.Drawing.Size(171, 134);
			this.lbCustomers.TabIndex = 9;
			this.lbCustomers.ValueMember = "Representatives.RepresentativesCustomerList.RepID";
			// 
			// lbReps
			// 
			this.lbReps.DataSource = this.dsFrmChapter13;
			this.lbReps.DisplayMember = "Representatives.RepName";
			this.lbReps.Location = new System.Drawing.Point(19, 24);
			this.lbReps.Name = "lbReps";
			this.lbReps.Size = new System.Drawing.Size(171, 134);
			this.lbReps.TabIndex = 8;
			this.lbReps.ValueMember = "Representatives.RepID";
			// 
			// FilteredListbox
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(424, 173);
			this.Controls.Add(this.lbCustomers);
			this.Controls.Add(this.lbReps);
			this.Controls.Add(this.Label2);
			this.Controls.Add(this.Label1);
			this.Name = "FilteredListbox";
			this.Text = "FilteredListbox";
			((System.ComponentModel.ISupportInitialize)(this.dsFrmChapter13)).EndInit();
			this.ResumeLayout(false);

		}
		#endregion
	}
}
