using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;

namespace UserCustomizationCSharp
{
	/// <summary>
	/// Summary description for MRU.
	/// </summary>
	public class MRU : System.Windows.Forms.Form
	{
		private UserCustomizationCSharp.UserSettings dsUserSettings;
		internal System.Windows.Forms.Button Form;
		internal System.Windows.Forms.Label Label1;
		internal System.Windows.Forms.TextBox tbItemNumber;
		internal System.Windows.Forms.Button btnMRU;
		internal System.Windows.Forms.ListBox lbMRU;
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		public MRU()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			//
			// TODO: Add any constructor code after InitializeComponent call
			//
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if(components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.dsUserSettings = new UserCustomizationCSharp.UserSettings();
			this.Form = new System.Windows.Forms.Button();
			this.Label1 = new System.Windows.Forms.Label();
			this.tbItemNumber = new System.Windows.Forms.TextBox();
			this.btnMRU = new System.Windows.Forms.Button();
			this.lbMRU = new System.Windows.Forms.ListBox();
			((System.ComponentModel.ISupportInitialize)(this.dsUserSettings)).BeginInit();
			this.SuspendLayout();
			// 
			// dsUserSettings
			// 
			this.dsUserSettings.DataSetName = "UserSettings";
			this.dsUserSettings.Locale = new System.Globalization.CultureInfo("en-US");
			// 
			// Form
			// 
			this.Form.Location = new System.Drawing.Point(16, 120);
			this.Form.Name = "Form";
			this.Form.Size = new System.Drawing.Size(256, 23);
			this.Form.TabIndex = 9;
			this.Form.Text = "Show Form from Name";
			this.Form.Click += new System.EventHandler(this.Form_Click);
			// 
			// Label1
			// 
			this.Label1.AutoSize = true;
			this.Label1.Location = new System.Drawing.Point(176, 56);
			this.Label1.Name = "Label1";
			this.Label1.Size = new System.Drawing.Size(73, 16);
			this.Label1.TabIndex = 8;
			this.Label1.Text = "Item Number:";
			// 
			// tbItemNumber
			// 
			this.tbItemNumber.Location = new System.Drawing.Point(176, 72);
			this.tbItemNumber.Name = "tbItemNumber";
			this.tbItemNumber.TabIndex = 7;
			this.tbItemNumber.Text = "1";
			// 
			// btnMRU
			// 
			this.btnMRU.Location = new System.Drawing.Point(176, 16);
			this.btnMRU.Name = "btnMRU";
			this.btnMRU.Size = new System.Drawing.Size(96, 23);
			this.btnMRU.TabIndex = 6;
			this.btnMRU.Text = "Add MRU Item";
			this.btnMRU.Click += new System.EventHandler(this.btnMRU_Click);
			// 
			// lbMRU
			// 
			this.lbMRU.DataSource = this.dsUserSettings.MRU;
			this.lbMRU.DisplayMember = "UserField";
			this.lbMRU.Location = new System.Drawing.Point(16, 8);
			this.lbMRU.Name = "lbMRU";
			this.lbMRU.Size = new System.Drawing.Size(120, 95);
			this.lbMRU.TabIndex = 5;
			// 
			// MRU
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(288, 158);
			this.Controls.Add(this.Form);
			this.Controls.Add(this.Label1);
			this.Controls.Add(this.tbItemNumber);
			this.Controls.Add(this.btnMRU);
			this.Controls.Add(this.lbMRU);
			this.Name = "MRU";
			this.Text = "MRU";
			((System.ComponentModel.ISupportInitialize)(this.dsUserSettings)).EndInit();
			this.ResumeLayout(false);

		}
		#endregion

		private void btnMRU_Click(object sender, System.EventArgs e)
		{
			int maxRows = 5;
			int curRowIdx;
			UserSettings.MRUDataTable dt = this.dsUserSettings.MRU;

            dt.DefaultView.Sort = "PK";
            curRowIdx = dt.DefaultView.Find(tbItemNumber.Text);
			if ((Convert.IsDBNull(curRowIdx)) | (curRowIdx != -1))
				dt.Rows[curRowIdx]["LastUsed"] = DateTime.Now;
			else
			{
				UserSettings.MRURow newRow = dt.NewMRURow();

				newRow.LastUsed = DateTime.Now;
				newRow = dt.NewMRURow();
				newRow.PK = this.tbItemNumber.Text;
				newRow.UserField = "Item " + this.tbItemNumber.Text;
				dt.Rows.Add(newRow);

				if (dt.Rows.Count > maxRows)
				{
					dt.DefaultView.Sort = "LastUsed DESC";
					dt.Rows.RemoveAt(0);
				}
			}

			this.tbItemNumber.Text = (int.Parse(this.tbItemNumber.Text) + 1).ToString();
		}

		private void Form_Click(object sender, System.EventArgs e)
		{
			Type myType = Type.GetType("UserCustomizationCSharp.Form1");

			System.Reflection.ConstructorInfo myNew;
			myNew = myType.GetConstructor(Type.EmptyTypes);

			Form myForm;
			myForm = myNew.Invoke(null) as Form;

			myForm.Show();
		}
	}
}
