using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;

namespace ListControlsCSharp
{
	/// <summary>
	/// Summary description for UpdateCombo.
	/// </summary>
	public class UpdateCombo : System.Windows.Forms.Form
	{
		private ListControlsCSharp.dsChapter13 dsFrmChapter13;
		bool inEdit = false;
		int position;
		internal System.Data.OleDb.OleDbCommand OleDbSelectCommand2;
		internal System.Data.OleDb.OleDbConnection cnChapter13;
		internal System.Data.OleDb.OleDbDataAdapter daRepresentatives;
		internal System.Data.OleDb.OleDbDataAdapter daCustomerList;
		internal System.Data.OleDb.OleDbCommand OleDbSelectCommand1;
		internal System.Windows.Forms.ComboBox cbSimple;
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		public UpdateCombo()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			try
			{
				this.daRepresentatives.Fill(this.dsFrmChapter13, "Representatives");
				this.daCustomerList.Fill(this.dsFrmChapter13, "CustomerList");
			}
			catch (Exception ex)
			{
				MessageBox.Show(ex.Message);
			}

		
		    this.cbSimple.Items.AddRange(this.dsFrmChapter13.CustomerList.Select());
			this.cbSimple.Items.Insert(0, "(New)");
			this.cbSimple.DisplayMember = "CustomerName";	
}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if(components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.dsFrmChapter13 = new ListControlsCSharp.dsChapter13();
			this.OleDbSelectCommand2 = new System.Data.OleDb.OleDbCommand();
			this.cnChapter13 = new System.Data.OleDb.OleDbConnection();
			this.daRepresentatives = new System.Data.OleDb.OleDbDataAdapter();
			this.daCustomerList = new System.Data.OleDb.OleDbDataAdapter();
			this.OleDbSelectCommand1 = new System.Data.OleDb.OleDbCommand();
			this.cbSimple = new System.Windows.Forms.ComboBox();
			((System.ComponentModel.ISupportInitialize)(this.dsFrmChapter13)).BeginInit();
			this.SuspendLayout();
			// 
			// dsFrmChapter13
			// 
			this.dsFrmChapter13.DataSetName = "dsChapter13";
			this.dsFrmChapter13.Locale = new System.Globalization.CultureInfo("en-US");
			// 
			// OleDbSelectCommand2
			// 
			this.OleDbSelectCommand2.CommandText = "SELECT RepID, RepName FROM Representatives";
			this.OleDbSelectCommand2.Connection = this.cnChapter13;
			// 
			// cnChapter13
			// 
			this.cnChapter13.ConnectionString = @"Jet OLEDB:Global Partial Bulk Ops=2;Jet OLEDB:Registry Path=;Jet OLEDB:Database Locking Mode=1;Data Source=""..\..\Chapter13.mdb"";Jet OLEDB:Engine Type=5;Provider=""Microsoft.Jet.OLEDB.4.0"";Jet OLEDB:System database=;Jet OLEDB:SFP=False;persist security info=False;Extended Properties=;Mode=Share Deny None;Jet OLEDB:Encrypt Database=False;Jet OLEDB:Create System Database=False;Jet OLEDB:Don't Copy Locale on Compact=False;Jet OLEDB:Compact Without Replica Repair=False;User ID=Admin;Jet OLEDB:Global Bulk Transactions=1";
			// 
			// daRepresentatives
			// 
			this.daRepresentatives.SelectCommand = this.OleDbSelectCommand2;
			this.daRepresentatives.TableMappings.AddRange(new System.Data.Common.DataTableMapping[] {
																										new System.Data.Common.DataTableMapping("Table", "Representatives", new System.Data.Common.DataColumnMapping[] {
																																																						   new System.Data.Common.DataColumnMapping("RepID", "RepID"),
																																																						   new System.Data.Common.DataColumnMapping("RepName", "RepName")})});
			// 
			// daCustomerList
			// 
			this.daCustomerList.SelectCommand = this.OleDbSelectCommand1;
			this.daCustomerList.TableMappings.AddRange(new System.Data.Common.DataTableMapping[] {
																									 new System.Data.Common.DataTableMapping("Table", "CustomerList", new System.Data.Common.DataColumnMapping[] {
																																																					 new System.Data.Common.DataColumnMapping("CustomerID", "CustomerID"),
																																																					 new System.Data.Common.DataColumnMapping("CustomerName", "CustomerName"),
																																																					 new System.Data.Common.DataColumnMapping("RepID", "RepID")})});
			// 
			// OleDbSelectCommand1
			// 
			this.OleDbSelectCommand1.CommandText = "SELECT CustomerID, CustomerName, RepID FROM CustomerList";
			this.OleDbSelectCommand1.Connection = this.cnChapter13;
			// 
			// cbSimple
			// 
			this.cbSimple.DropDownStyle = System.Windows.Forms.ComboBoxStyle.Simple;
			this.cbSimple.Location = new System.Drawing.Point(24, 14);
			this.cbSimple.Name = "cbSimple";
			this.cbSimple.Size = new System.Drawing.Size(160, 184);
			this.cbSimple.TabIndex = 1;
			this.cbSimple.KeyPress += new System.Windows.Forms.KeyPressEventHandler(this.cbSimple_KeyPress);
			// 
			// UpdateCombo
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(232, 213);
			this.Controls.Add(this.cbSimple);
			this.Name = "UpdateCombo";
			this.Text = "UpdateCombo";
			((System.ComponentModel.ISupportInitialize)(this.dsFrmChapter13)).EndInit();
			this.ResumeLayout(false);

		}
		#endregion

		private void cbSimple_KeyPress(object sender, System.Windows.Forms.KeyPressEventArgs e)
		{
			if (e.KeyChar == (char)13) //enter key
			{
				UpdateValue(position);
				inEdit = false;
				e.Handled = true;
			}
			else
			{
				if (inEdit == false)
				{
					inEdit = true;
					position = this.cbSimple.SelectedIndex;
				}
			}
		}

		private void UpdateValue(int position)
		{
			if (position == 0)
			{
				//handle a new row
			}
			else
			{
				DataView dv = this.dsFrmChapter13.CustomerList.DefaultView;
				dv.Sort = this.cbSimple.DisplayMember;

				DataRow oldValue = (DataRow)this.cbSimple.Items[position];
				int idx = dv.Find(oldValue[this.cbSimple.DisplayMember]);

				DataRow dr = this.dsFrmChapter13.CustomerList.Rows[idx];
				dr[this.cbSimple.DisplayMember] = this.cbSimple.Text;

				this.cbSimple.Items.RemoveAt(position);
				this.cbSimple.Items.Insert(position, dr);
			}
		}
	}
}
